/*
 * OperationRegister.java
 *
 * Created on 11  2010 ., 17:39
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
package com.shtrih.fiscalprinter.command;

/**
 *
 * @author V.Kravtsov
 */
public class OperationRegister {

    private int value;
    private final int number;

    public OperationRegister(int number) {
        this.number = number;
    }

    public int getNumber() {
        return number;
    }

    public int getValue() {
        return value;
    }

    public void setValue(int value) {
        this.value = value;
    }

    public static String getRusName(int number) {
        if ((number >= 0) && (number < rusNames.length)) {
            return rusNames[number];
        } else {
            return "  ";
        }
    }

    public static String getEngName(int number) {
        if ((number >= 0) && (number < engNames.length)) {
            return engNames[number];
        } else {
            return "Unknown register";
        }
    }

    public static String getName(int number) {
        return getRusName(number);
    }
    private static final String[] rusNames = {
        "   1   ",
        "   1   ",
        "    1   ",
        "    1   ",
        "   2   ",
        "   2   ",
        "    2   ",
        "    2   ",
        "   3   ",
        "   3   ",
        "    3   ",
        "    3   ",
        "   4   ",
        "   4   ",
        "    4   ",
        "    4   ",
        "   5   ",
        "   5   ",
        "    5   ",
        "    5   ",
        "   6   ",
        "   6   ",
        "    6   ",
        "    6   ",
        "   7   ",
        "   7   ",
        "    7   ",
        "    7   ",
        "   8   ",
        "   8   ",
        "    8   ",
        "    8   ",
        "   9   ",
        "   9   ",
        "    9   ",
        "    9   ",
        "   10   ",
        "   10   ",
        "    10   ",
        "    10   ",
        "   11   ",
        "   11   ",
        "    11   ",
        "    11   ",
        "   12   ",
        "   12   ",
        "    12   ",
        "    12   ",
        "   13   ",
        "   13   ",
        "    13   ",
        "    13   ",
        "   14   ",
        "   14   ",
        "    14   ",
        "    14   ",
        "   15   ",
        "   15   ",
        "    15   ",
        "    15   ",
        "   16   ",
        "   16   ",
        "    16   ",
        "    16   ",
        "     ",
        "     ",
        "      ",
        "      ",
        "     ",
        "     ",
        "      ",
        "      ",
        "   1   ",
        "   1   ",
        "    1   ",
        "    1   ",
        "   2   ",
        "   2   ",
        "    2   ",
        "    2   ",
        "   3   ",
        "   3   ",
        "    3   ",
        "    3   ",
        "   4   ",
        "   4   ",
        "    4   ",
        "    4   ",
        "   5   ",
        "   5   ",
        "    5   ",
        "    5   ",
        "   6   ",
        "   6   ",
        "    6   ",
        "    6   ",
        "   7   ",
        "   7   ",
        "    7   ",
        "    7   ",
        "   8   ",
        "   8   ",
        "    8   ",
        "    8   ",
        "   9   ",
        "   9   ",
        "    9   ",
        "    9   ",
        "   10   ",
        "   10   ",
        "    10   ",
        "    10   ",
        "   11   ",
        "   11   ",
        "    11   ",
        "    11   ",
        "   12   ",
        "   12   ",
        "    12   ",
        "    12   ",
        "   13   ",
        "   13   ",
        "    13   ",
        "    13   ",
        "   14   ",
        "   14   ",
        "    14   ",
        "    14   ",
        "   15   ",
        "   15   ",
        "    15   ",
        "    15   ",
        "   16   ",
        "   16   ",
        "    16   ",
        "    16   ",
        "     ",
        "     ",
        "      ",
        "      ",
        "     ",
        "     ",
        "      ",
        "      ",
        "    ",
        "    ",
        "     ",
        "     ",
        "  ",
        "  ",
        "   ",
        "   ",
        "  ",
        "     ",
        "     ",
        "   ",
        "   ",
        "    ",
        "    ",
        "      ",
        "  ",
        "   ",
        "   ",
        "  ",
        "    ",
        "   ",
        " ",
        "   ",
        "  ",
        "     ",
        "        ",
        "      ",
        "      ",
        "      ",
        "       ",
        "        ",
        "        ",
        "   ",
        "   ",
        "   ",
        "   ",
        "    ",
        "    ",
        "    ",
        "  ",
        "  "
    };
    private static final String[] engNames = {
        "Sales quantity in department 1 in receipt",
        "Buy quantity in department 1 in receipt",
        "Sales return quantity in department 1 in receipt",
        "Buy return quantity in department 1 in receipt",
        "Sales quantity in department 2 in receipt",
        "Buy quantity in department 2 in receipt",
        "Sales return quantity in department 2 in receipt",
        "Buy return quantity in department 2 in receipt",
        "Sales quantity in department 3 in receipt",
        "Buy quantity in department 3 in receipt",
        "Sales return quantity in department 3 in receipt",
        "Buy return quantity in department 3 in receipt",
        "Sales quantity in department 4 in receipt",
        "Buy quantity in department 4 in receipt",
        "Sales return quantity in department 4 in receipt",
        "Buy return quantity in department 4 in receipt",
        "Sales quantity in department 5 in receipt",
        "Buy quantity in department 5 in receipt",
        "Sales return quantity in department 5 in receipt",
        "Buy return quantity in department 5 in receipt",
        "Sales quantity in department 6 in receipt",
        "Buy quantity in department 6 in receipt",
        "Sales return quantity in department 6 in receipt",
        "Buy return quantity in department 6 in receipt",
        "Sales quantity in department 7 in receipt",
        "Buy quantity in department 7 in receipt",
        "Sales return quantity in department 7 in receipt",
        "Buy return quantity in department 7 in receipt",
        "Sales quantity in department 8 in receipt",
        "Buy quantity in department 8 in receipt",
        "Sales return quantity in department 8 in receipt",
        "Buy return quantity in department 8 in receipt",
        "Sales quantity in department 9 in receipt",
        "Buy quantity in department 9 in receipt",
        "Sales return quantity in department 9 in receipt",
        "Buy return quantity in department 9 in receipt",
        "Sales quantity in department 10 in receipt",
        "Buy quantity in department 10 in receipt",
        "Sales return quantity in department 10 in receipt",
        "Buy return quantity in department 10 in receipt",
        "Sales quantity in department 11 in receipt",
        "Buy quantity in department 11 in receipt",
        "Sales return quantity in department 11 in receipt",
        "Buy return quantity in department 11 in receipt",
        "Sales quantity in department 12 in receipt",
        "Buy quantity in department 12 in receipt",
        "Sales return quantity in department 12 in receipt",
        "Buy return quantity in department 12 in receipt",
        "Sales quantity in department 13 in receipt",
        "Buy quantity in department 13 in receipt",
        "Sales return quantity in department 13 in receipt",
        "Buy return quantity in department 13 in receipt",
        "Sales quantity in department 14 in receipt",
        "Buy quantity in department 14 in receipt",
        "Sales return quantity in department 14 in receipt",
        "Buy return quantity in department 14 in receipt",
        "Sales quantity in department 15 in receipt",
        "Buy quantity in department 15 in receipt",
        "Sales return quantity in department 15 in receipt",
        "Buy return quantity in department 15 in receipt",
        "Sales quantity in department 16 in receipt",
        "Buy quantity in department 16 in receipt",
        "Sales return quantity in department 16 in receipt",
        "Buy return quantity in department 16 in receipt",
        "Discount quantity on sale in receipt",
        "Discount quantity on buy in receipt",
        "Discount quantity on sale refund in receipt",
        "Discount quantity on buy refund in receipt",
        "Charge quantity on sale in receipt",
        "Charge quantity on buy in receipt",
        "Charge quantity on sale refund in receipt",
        "Charge quantity on buy refund in receipt",
        "Daily sale quantity in department 1",
        "Daily buy quantity in department 1",
        "Daily sales return quantity in department 1",
        "Daily buy return quantity in department 1",
        "Daily sale quantity in department 2",
        "Daily buy quantity in department 2",
        "Daily sales return quantity in department 2",
        "Daily buy return quantity in department 2",
        "Daily sale quantity in department 3",
        "Daily buy quantity in department 3",
        "Daily sales return quantity in department 3",
        "Daily buy return quantity in department 3",
        "Daily sale quantity in department 4",
        "Daily buy quantity in department 4",
        "Daily sales return quantity in department 4",
        "Daily buy return quantity in department 4",
        "Daily sale quantity in department 5",
        "Daily buy quantity in department 5",
        "Daily sales return quantity in department 5",
        "Daily buy return quantity in department 5",
        "Daily sale quantity in department 6",
        "Daily buy quantity in department 6",
        "Daily sales return quantity in department 6",
        "Daily buy return quantity in department 6",
        "Daily sale quantity in department 7",
        "Daily buy quantity in department 7",
        "Daily sales return quantity in department 7",
        "Daily buy return quantity in department 7",
        "Daily sale quantity in department 8",
        "Daily buy quantity in department 8",
        "Daily sales return quantity in department 8",
        "Daily buy return quantity in department 8",
        "Daily sale quantity in department 9",
        "Daily buy quantity in department 9",
        "Daily sales return quantity in department 9",
        "Daily buy return quantity in department 9",
        "Daily sale quantity in department 10",
        "Daily buy quantity in department 10",
        "Daily sales return quantity in department 10",
        "Daily buy return quantity in department 10",
        "Daily sale quantity in department 11",
        "Daily buy quantity in department 11",
        "Daily sales return quantity in department 11",
        "Daily buy return quantity in department 11",
        "Daily sale quantity in department 12",
        "Daily buy quantity in department 12",
        "Daily sales return quantity in department 12",
        "Daily buy return quantity in department 12",
        "Daily sale quantity in department 13",
        "Daily buy quantity in department 13",
        "Daily sales return quantity in department 13",
        "Daily buy return quantity in department 13",
        "Daily sale quantity in department 14",
        "Daily buy quantity in department 14",
        "Daily sales return quantity in department 14",
        "Daily buy return quantity in department 14",
        "Daily sale quantity in department 15",
        "Daily buy quantity in department 15",
        "Daily sales return quantity in department 15",
        "Daily buy return quantity in department 15",
        "Daily sale quantity in department 16",
        "Daily buy quantity in department 16",
        "Daily sales return quantity in department 16",
        "Daily buy return quantity in department 16",
        "Daily discount quantity on sale",
        "Daily discount quantity on buy",
        "Daily discount quantity on sale refund",
        "Daily discount quantity on buy refund",
        "Daily charge quantity on sale",
        "Daily charge quantity on buy",
        "Daily charge quantity on sale refund",
        "Daily charge quantity on buy refund",
        "Daily sale receipts quantity",
        "Daily buy receipts quantity",
        "Daily sales refund receipts quantity",
        "Daily buy refund receipts quantity",
        "Sale receipt number",
        "Buy receipt number",
        "Sale refund receipt number",
        "Buy refund receipt number",
        "Document number",
        "Daily cashin quantity",
        "Daily cashout quantity",
        "Cashin receipt number",
        "Cashout receipt number",
        "Daily voided receipt number",
        "X report number",
        "Z report number before fiscalization",
        "Total reset number",
        "Full fiscal report number",
        "Short fiscal report number",
        "Test report number",
        "Operation report number",
        "Department report number",
        "Voided receipt number",
        "Test report quantity",
        "EJ activation quantity",
        "EJ activation report quantity",
        "EJ CRC report quantity",
        "EJ jourbal report quantity",
        "EJ date report quantity",
        "EJ day report quantity",
        "EJ day totals report quantity",
        "EJ date and department report quantity",
        "EJ day and department report quantity",
        "EJ close quantity",
        "Tax report number",
        "Voided sale receipt quantity",
        "Voided buy receipt quantity",
        "Voided sale refund receipt quantity",
        "Voided buy refund receipt quantity",
        "Daily fiscal document quantity",
        "Daily nonfiscal document quantity",
        "Document number"
    };
}
